package org.jabricks.templates;

/**
 * Активатор формы
 */

import javax.swing.JFrame;

import java.util.Locale;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.ActionListener;

import org.osgi.framework.BundleContext;
import org.jabricks.jdialog.JBDialogActivator;

public class JDialogActivator extends JBDialogActivator
{
	private  JDialogForm  form  = null;	
    //-----------------------------------------------------------------------------------------------------------------
	/**
	 * Процедура старта, вызывается фреймворком
	 * @param context   
	 */
	@Override
    public void start(final BundleContext context) throws Exception
    {
		super.start(context);

        JFrame.setDefaultLookAndFeelDecorated(true);
        form = new JDialogForm(context);

        form.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent we) {
            	form.setVisible(false);
            	try {
            		// Останов бандла
            		context.getBundle().stop();
        		} catch (Exception e) {}
            }
        });
        form.btnOk   .addActionListener(okListener);
        form.btnClose.addActionListener(closeListener);
        
        form.repaint();
               
        // Открытие окна
        form.setVisible(true);
        
        // Подключение слушателей
        createLocaleSubscriber();
    }
    //-----------------------------------------------------------------------------------------------------------------
    @Override
    public void changeLocale (Locale locale) 
    {
    	form.changeLocale(locale);
    }
    //-----------------------------------------------------------------------------------------------------------------
	/**
	 * Метод закрытия формы
	 */
    private void closeForm()
    {
 		form.setVisible(false);
		form.dispose();
		try {
			context.getBundle().stop();
		} catch (Exception e) {}
    }
    //-----------------------------------------------------------------------------------------------------------------
    ActionListener closeListener = new ActionListener()
    {
		public void actionPerformed(ActionEvent arg0)
		{
			closeForm();
		}
    };
    //-----------------------------------------------------------------------------------------------------------------
    ActionListener okListener = new ActionListener()
    {
		public void actionPerformed(ActionEvent arg0)
		{
			closeForm();
		}
    };
    //-----------------------------------------------------------------------------------------------------------------
	/**
	 * Callback метод сохранения параметров настроек интерфейса панели. Вызывается перед остановкой бандла из 
	 * подписчика GuiSaverSubscriber.
	 */
	public void saveComponentParams() 
	{
		if (form != null)
			form.saveComponentParams();
	}
    //-----------------------------------------------------------------------------------------------------------------
}
