package org.jabricks.templates;

import java.awt.*;

import javax.swing.*;

// import org.jabricks.db.objects.Connect;
import org.jabricks.jdialog.JBDialog;
import org.osgi.framework.BundleContext;
import org.jabricks.resources.IResources;
import org.jabricks.resources.ResourcesImpl;

import java.util.Locale;
import java.util.ResourceBundle;

public class JDialogForm extends JBDialog
{
	private static final long  serialVersionUID     = 1L;
	
	private        int         DEFAULT_WIDTH        = 420;
	private        int         DEFAULT_HEIGHT       = 315;

	public   JButton           btnOk                = null;
	public   JButton           btnClose             = null;
	private  ResourceBundle    resources            = null;
    
	public   String            CONNECTION_failed    = null;
	
	private  final   String    RESOURCES_btn_ok     = "btn.ok"    ;
	private  final   String    RESOURCES_btn_cancel = "btn.close" ;

	private  final   String    RESOURCES            = "properties/properties";
    //---------------------------------------------------------------------------------------------------
	public JDialogForm(final BundleContext context)
	{
		super(context);
		
        IResources rsc = new ResourcesImpl();
        // Определение иконки
       	if (rsc != null)
       		setIconImage(rsc.getAppIcon());

		// Создание интерфейса GUI
        this.setVisible(false);

    	readComponentParams();
		if (form_dim != null) {
			setSize(form_dim);
			DEFAULT_WIDTH  = form_dim.width;
			DEFAULT_HEIGHT = form_dim.height;
		}
        createGUI(locale);

        // Получение панели содержимого
        Container container = getContentPane();
        
        // Размещение панели desk
		container.add(pnlDesk, BorderLayout.CENTER);
        // Размещение панели с кнопками
        container.add(createButtons(), BorderLayout.SOUTH);
        
        changeLocale (locale);

		// Центрирование формы
		formCentering(DEFAULT_WIDTH, DEFAULT_HEIGHT);

       	// Расположение поверх остальных
		setAlwaysOnTop(true);

		this.setVisible(true);
	}
    //---------------------------------------------------------------------------------------------------
	/**
	 * Создание интерфейса рабочей области формы
	 * @param locale текущая локализация. Используется для определения значения RadioButton
	 */
    private void createGUI(final Locale locale)
    {
    	// Создание рабочей области
    	super.createDesk();
		boolean is_first = context.getBundle().getVersion().toString().equalsIgnoreCase("1.0.0");
		if (is_first) {
			// 1.0.0
			pnlDesk.setBackground(Color.red);
		} else {
			// 2.0.0
			pnlDesk .setBackground(Color.blue);
		}
    }
    //---------------------------------------------------------------------------------------------------
	/**
	 * Создание панели кнопок управления
	 * @return панели управления JPanel
	 */
    private JPanel createButtons()
    {
        String caption = EMPTY;
        // Кнопка ОК в панель
        btnOk = new JButton(caption);
        // Кнопка Закрыть
        btnClose = new JButton(caption);

        btnOk   .setPreferredSize(new Dimension(BUTTON_width + 15, BUTTON_height));
        btnClose.setPreferredSize(new Dimension(BUTTON_width, BUTTON_height));
        
        /*
         *  Создание панели 'pnlButtons' с последовательным расположением компонентов
         *  и выравниванием по правому краю 'flow'
         */
        JPanel flow = super.createButtonsPanel(); 
        pnlButtons.add (btnOk   );
        pnlButtons.add (btnClose);
        
        return flow;
    }
    //---------------------------------------------------------------------------------------------------
    /**
     * Процедура локализации интерфейса после нажатия кнопки btnOk
     * @param locale объект локализации
     */
    public void changeLocale (Locale locale)
    {
		resources = ResourceBundle.getBundle (RESOURCES, locale);

		String ok      = RESOURCES_btn_ok;
		String cancel  = RESOURCES_btn_cancel;
		String caption = RESOURCE_title;
		
		if (resources != null) {
			caption = resources.getString(RESOURCE_title);
			ok      = SPAN_normal + resources.getString(ok    );
			cancel  = SPAN_normal + resources.getString(cancel);
		}
		this.setTitle(caption);
		btnOk      .setText(ok    );
		btnClose   .setText(cancel);
    }
    //---------------------------------------------------------------------------------------------------
}
